--- old/usr/src/uts/common/fs/nfs/nfs3_vnops.c	Fri Jan 18 13:59:18 2013
+++ new/usr/src/uts/common/fs/nfs/nfs3_vnops.c	Fri Jan 18 13:59:18 2013
@@ -28,6 +28,10 @@
  *	All rights reserved.
  */
 
+/*
+ * Copyright (c) 2013, Joyent, Inc. All rights reserved.
+ */
+
 #include <sys/param.h>
 #include <sys/types.h>
 #include <sys/systm.h>
@@ -2298,6 +2302,12 @@
 						vattr.va_mask = AT_SIZE;
 						error = nfs3setattr(vp,
 						    &vattr, 0, cr);
+
+						/*
+						 * Existing file was truncated;
+						 * emit a create event.
+						 */
+						vnevent_create(vp, ct);
 					}
 				}
 			}
@@ -2306,12 +2316,9 @@
 		if (error) {
 			VN_RELE(vp);
 		} else {
-			/*
-			 * existing file got truncated, notify.
-			 */
-			vnevent_create(vp, ct);
 			*vpp = vp;
 		}
+
 		return (error);
 	}
 
